diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancy.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancy.java
index 95f58d6bd..509a2e260 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancy.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancy.java
@@ -15,6 +15,25 @@ public class WorldFeatureTreeFancy extends WorldFeature
 {
 	protected int leavesID;
 	protected int logID;
+
+    static final byte[] dimensionLookup = {
+        2, 0, 0, 1, 2, 1
+    };
+    Random treeRand;
+    World worldObj;
+    int[] pos = { 0, 0, 0 };
+    int height;
+    int trunkHeight;
+    double trunkHeightScale;
+    double field_875_h;
+    double branchSlope;
+    double field_873_j;
+    double field_872_k;
+    int trunkThickness;
+    int trunkHeightVariance;
+    int leavesHeight;
+    int[][] foliageCoords;
+    int heightMod;
 	
     public WorldFeatureTreeFancy(int leavesID, int logID)
     {
@@ -27,7 +46,7 @@ public class WorldFeatureTreeFancy extends WorldFeature
         height = 0;
         trunkHeightScale = 0.6D;
         field_875_h = 1.0D;
-        field_874_i = 0.4D;
+        branchSlope = 0.4D;
         field_873_j = 1.0D;
         field_872_k = 1.0D;
         trunkThickness = 1;
@@ -38,134 +57,120 @@ public class WorldFeatureTreeFancy extends WorldFeature
         this.heightMod = heightMod;
     }
 
-    void generateBranchPoints()
+    void prepare()
     {
         trunkHeight = (int)((double) height * trunkHeightScale);
-        if(trunkHeight >= height)
+        if (trunkHeight >= height)
         {
             trunkHeight = height - 1;
         }
-        int numBranchPoints = (int)(1.4D + Math.pow((field_872_k * (double) height) / 13D, 2D));
-        if(numBranchPoints < 1)
-        {
-            numBranchPoints = 1;
-        }
-        int[][] branchPoints = new int[numBranchPoints * height][4];
-        int highestBranchY = (basePos[1] + height) - leavesHeight;
-        int branchIndex = 1;
-        int trunkTop = basePos[1] + trunkHeight;
-        int dy = highestBranchY - basePos[1];
-        branchPoints[0][0] = basePos[0];
-        branchPoints[0][1] = highestBranchY;
-        branchPoints[0][2] = basePos[2];
-        branchPoints[0][3] = trunkTop;
-        highestBranchY--;
-        while(dy >= 0)
-        {
-            float f = func_528_a(dy);
-            if(f < 0.0F)
-            {
-                highestBranchY--;
-                dy--;
-            }
-            else
-            {
-                double d = 0.5D;
-                for(int j1 = 0; j1 < numBranchPoints; j1++)
-                {
-                    double branchRadius = field_873_j * ((double)f * ((double) treeRand.nextFloat() + 0.328D));
-                    double branchAngle = (double) treeRand.nextFloat() * 2D * Math.PI;
-                    int branchX = MathHelper.floor_double(branchRadius * Math.sin(branchAngle) + (double)basePos[0] + d);
-                    int branchZ = MathHelper.floor_double(branchRadius * Math.cos(branchAngle) + (double)basePos[2] + d);
-                    int[] branchEnd = { branchX, highestBranchY, branchZ };
-                    int[] branchTopOfTree = { branchX, highestBranchY + leavesHeight, branchZ };
-                    if(drawLineAndStopIfInterrupted(branchEnd, branchTopOfTree) != -1)
-                    {
+        int numOfClustersPerY = (int)(1.4D + Math.pow((field_872_k * (double) height) / 13D, 2D));
+        if (numOfClustersPerY < 1)
+        {
+            numOfClustersPerY = 1;
+        }
+        int[][] foliageCoords = new int[numOfClustersPerY * height][4];
+        int yEnd = (pos[1] + height) - leavesHeight;
+        int foliageCoordsIndex = 1;
+        int topY = pos[1] + trunkHeight;
+        int y = yEnd - pos[1];
+        foliageCoords[0][0] = pos[0];
+        foliageCoords[0][1] = yEnd;
+        foliageCoords[0][2] = pos[2];
+        foliageCoords[0][3] = topY;
+        yEnd--;
+        while (y >= 0) {
+            float shapeFac = shapeFunc(y);
+            if (shapeFac < 0.0F) {
+                yEnd--;
+                y--;
+            } else {
+                double offset = 0.5D;
+                for (int i = 0; i < numOfClustersPerY; i++) {
+                    double r = field_873_j * ((double)shapeFac * ((double) treeRand.nextFloat() + 0.328D));
+                    double theta = (double) treeRand.nextFloat() * 2D * Math.PI;
+                    int x = MathHelper.floor_double(r * Math.sin(theta) + (double) pos[0] + offset);
+                    int z = MathHelper.floor_double(r * Math.cos(theta) + (double) pos[2] + offset);
+                    int[] branchEnd = { x, yEnd, z };
+                    int[] branchTopOfTree = { x, yEnd + leavesHeight, z };
+                    if (distToMat(branchEnd, branchTopOfTree) != -1) {
                         continue;
                     }
-                    int[] branchStart = { basePos[0], basePos[1], basePos[2] };
-                    double branchLength = Math.sqrt(Math.pow(Math.abs(basePos[0] - branchEnd[0]), 2D) + Math.pow(Math.abs(basePos[2] - branchEnd[2]), 2D));
-                    double d4 = branchLength * field_874_i;
-                    if((double)branchEnd[1] - d4 > (double)trunkTop)
-                    {
-                        branchStart[1] = trunkTop;
+                    int[] branchStart = { pos[0], pos[1], pos[2] };
+                    double dist = Math.sqrt(Math.pow(Math.abs(pos[0] - branchEnd[0]), 2D) + Math.pow(Math.abs(pos[2] - branchEnd[2]), 2D));
+                    if ((double)branchEnd[1] - dist * branchSlope > (double)topY) {
+                        branchStart[1] = topY;
                     }
-                    else
-                    {
-                        branchStart[1] = (int)((double)branchEnd[1] - d4);
+                    else {
+                        branchStart[1] = (int)((double)branchEnd[1] - dist * branchSlope);
                     }
-                    if(drawLineAndStopIfInterrupted(branchStart, branchEnd) == -1)
-                    {
-                        branchPoints[branchIndex][0] = branchX;
-                        branchPoints[branchIndex][1] = highestBranchY;
-                        branchPoints[branchIndex][2] = branchZ;
-                        branchPoints[branchIndex][3] = branchStart[1];
-                        branchIndex++;
+                    if(distToMat(branchStart, branchEnd) == -1) {
+                        foliageCoords[foliageCoordsIndex][0] = x;
+                        foliageCoords[foliageCoordsIndex][1] = yEnd;
+                        foliageCoords[foliageCoordsIndex][2] = z;
+                        foliageCoords[foliageCoordsIndex][3] = branchStart[1];
+                        foliageCoordsIndex++;
                     }
                 }
 
-                highestBranchY--;
-                dy--;
+                yEnd--;
+                y--;
             }
         }
-        this.branchPoints = new int[branchIndex][4];
-        System.arraycopy(branchPoints, 0, this.branchPoints, 0, branchIndex);
+        this.foliageCoords = new int[foliageCoordsIndex][4];
+        System.arraycopy(foliageCoords, 0, this.foliageCoords, 0, foliageCoordsIndex);
     }
 
-    void placeLeafCircle(int x, int y, int z, float radius, int blockId)
+    void crossSection(int x, int y, int z, float radius, int blockId)
     {
-        int radiusBlocks = (int)((double)radius + 0.6D);
+        int rad = (int)(radius + 0.618D);
 
-        int[] centrePos = { x, y, z };
-        int[] lookupPos = { 0, 0, 0 };
+        int[] center = { x, y, z };
+        int[] coord = { 0, 0, 0 };
 
-        lookupPos[1] = centrePos[1];
-        for(int dx = -radiusBlocks; dx <= radiusBlocks; dx++)
+        coord[1] = center[1];
+        for(int off1 = -rad; off1 <= rad; off1++)
         {
-            lookupPos[0] = centrePos[0] + dx;
+            coord[0] = center[0] + off1;
 
-            for(int dz = -radiusBlocks; dz <= radiusBlocks; dz++)
+            for(int off2 = -rad; off2 <= rad; off2++)
             {
-                lookupPos[2] = centrePos[2] + dz;
+                coord[2] = center[2] + off2;
 
-                double distance = Math.sqrt(Math.pow((double) Math.abs(dx) + 0.5D, 2D) + Math.pow((double) Math.abs(dz) + 0.5D, 2D));
-                if(distance <= (double)radius)
+                double thisDist = Math.sqrt(Math.pow((double) Math.abs(off1) + 0.5D, 2D) + Math.pow((double) Math.abs(off2) + 0.5D, 2D));
+                if(thisDist <= (double)radius)
                 {
-                    int idAtBlock = worldObj.getBlockId(lookupPos[0], lookupPos[1], lookupPos[2]);
-                    if (idAtBlock == 0 || idAtBlock == leavesID)
+                    int id = worldObj.getBlockId(coord[0], coord[1], coord[2]);
+                    if (id == 0 || id == leavesID)
                     {
-                        worldObj.setBlockWithNotify(lookupPos[0], lookupPos[1], lookupPos[2], blockId);
+                        worldObj.setBlockWithNotify(coord[0], coord[1], coord[2], blockId);
                     }
                 }
             }
         }
     }
 
-    float func_528_a(int i)
+    float shapeFunc(int y)
     {
-        if((double)i < (double)(float) height * 0.3D)
+        if (y < height * 0.3D)
         {
             return -1.618F;
         }
-        float f = (float) height / 2.0F;
-        float f1 = (float) height / 2.0F - (float)i;
-        float f2;
-        if(f1 == 0.0F)
-        {
-            f2 = f;
-        } else
-        if(java.lang.Math.abs(f1) >= f)
-        {
-            f2 = 0.0F;
-        } else
-        {
-            f2 = (float) Math.sqrt(Math.pow(Math.abs(f), 2D) - Math.pow(Math.abs(f1), 2D));
-        }
-        f2 *= 0.5F;
-        return f2;
+        float radius = height / 2.0F;
+        float adj = height / 2.0F - y;
+        float dist;
+        if (adj == 0.0F) {
+            dist = radius;
+        } else if (java.lang.Math.abs(adj) >= radius) {
+            dist = 0.0F;
+        } else {
+            dist = (float) Math.sqrt(Math.pow(Math.abs(radius), 2D) - Math.pow(Math.abs(adj), 2D));
+        }
+        dist *= 0.5F;
+        return dist;
     }
 
-    float getLeavesRadius(int y)
+    float getFoliageShape(int y)
     {
         if(y < 0 || y >= leavesHeight)
         {
@@ -181,27 +186,27 @@ public class WorldFeatureTreeFancy extends WorldFeature
         }
     }
 
-    void placeLeafSphere(int x, int y, int z)
+    void foliageCluster(int x, int y, int z)
     {
         for(int leavesY = y; leavesY < y + leavesHeight; leavesY++)
         {
-            float leavesRadius = getLeavesRadius(leavesY - y);
-            placeLeafCircle(x, leavesY, z, leavesRadius, leavesID);
+            float radius = getFoliageShape(leavesY - y);
+            crossSection(x, leavesY, z, radius, leavesID);
         }
     }
 
-    void placeLeavesAtPoints()
+    void makeFoliage()
     {
-        for (int[] branchPoint : branchPoints)
+        for (int[] foliageCoord : foliageCoords)
         {
-            int x = branchPoint[0];
-            int y = branchPoint[1];
-            int z = branchPoint[2];
-            placeLeafSphere(x, y, z);
+            int x = foliageCoord[0];
+            int y = foliageCoord[1];
+            int z = foliageCoord[2];
+            foliageCluster(x, y, z);
         }
     }
 
-    void placeBranch(int[] startPos, int[] endPos, int blockId)
+    void makeBranch(int[] startPos, int[] endPos, int blockId)
     {
         int[] dimensions = { 0, 0, 0 };
         int dim0 = 0;
@@ -255,45 +260,45 @@ public class WorldFeatureTreeFancy extends WorldFeature
         return (double)i >= (double) height * 0.2D;
     }
 
-    void generateTrunk()
+    void makeTrunk()
     {
-        int x = basePos[0];
-        int minY = basePos[1];
-        int maxY = basePos[1] + trunkHeight;
-        int z = basePos[2];
+        int x = pos[0];
+        int minY = pos[1];
+        int maxY = pos[1] + trunkHeight;
+        int z = pos[2];
         int[] startPos = { x, minY, z };
         int[] endPos = { x, maxY, z };
-        placeBranch(startPos, endPos, logID);
+        makeBranch(startPos, endPos, logID);
         if(trunkThickness == 2)
         {
             startPos[0]++;
             endPos[0]++;
-            placeBranch(startPos, endPos, logID);
+            makeBranch(startPos, endPos, logID);
             startPos[2]++;
             endPos[2]++;
-            placeBranch(startPos, endPos, logID);
+            makeBranch(startPos, endPos, logID);
             startPos[0]--;
             endPos[0]--;
-            placeBranch(startPos, endPos, logID);
+            makeBranch(startPos, endPos, logID);
         }
     }
 
-    void generateBranches()
+    void makeBranches()
     {
-        int[] startPos = { basePos[0], basePos[1], basePos[2] };
-        for (int[] branchPoint : branchPoints)
+        int[] startPos = { pos[0], pos[1], pos[2] };
+        for (int[] branchPoint : foliageCoords)
         {
             int[] endPos = { branchPoint[0], branchPoint[1], branchPoint[2] };
             startPos[1] = branchPoint[3];
-            int dy = startPos[1] - basePos[1];
+            int dy = startPos[1] - pos[1];
             if (isHighEnoughToBranch(dy))
             {
-                placeBranch(startPos, endPos, logID);
+                makeBranch(startPos, endPos, logID);
             }
         }
     }
 
-    int drawLineAndStopIfInterrupted(int[] startPos, int[] endPos)
+    int distToMat(int[] startPos, int[] endPos)
     {
         int[] dimensions = { 0, 0, 0 };
         int dim0 = 0;
@@ -361,14 +366,14 @@ public class WorldFeatureTreeFancy extends WorldFeature
 
     boolean canGenerateTree()
     {
-        int[] bottomPos = { basePos[0], basePos[1], basePos[2] };
-        int[] topPos = { basePos[0], (basePos[1] + height) - 1, basePos[2] };
-        int blockIdUnderneath = worldObj.getBlockId(basePos[0], basePos[1] - 1, basePos[2]);
+        int[] bottomPos = { pos[0], pos[1], pos[2] };
+        int[] topPos = { pos[0], (pos[1] + height) - 1, pos[2] };
+        int blockIdUnderneath = worldObj.getBlockId(pos[0], pos[1] - 1, pos[2]);
         if(!Block.hasTag(blockIdUnderneath, BlockTags.GROWS_TREES))
         {
             return false;
         }
-        int interruptedTrunkHeight = drawLineAndStopIfInterrupted(bottomPos, topPos);
+        int interruptedTrunkHeight = distToMat(bottomPos, topPos);
         if(interruptedTrunkHeight == -1)
         {
             return true;
@@ -402,20 +407,20 @@ public class WorldFeatureTreeFancy extends WorldFeature
         worldObj = world;
         long seed = random.nextLong();
         treeRand.setSeed(seed);
-        basePos[0] = x;
-        basePos[1] = y;
-        basePos[2] = z;
+        pos[0] = x;
+        pos[1] = y;
+        pos[2] = z;
         if(height == 0)
         {
             height = 5 + treeRand.nextInt(trunkHeightVariance);
         }
         if(canGenerateTree())
         {
-            WorldFeatureTree.onTreeGrown(worldObj, basePos[0], basePos[1], basePos[2]);
-            generateBranchPoints();
-            placeLeavesAtPoints();
-            generateTrunk();
-            generateBranches();
+            WorldFeatureTree.onTreeGrown(worldObj, pos[0], pos[1], pos[2]);
+            prepare();
+            makeFoliage();
+            makeTrunk();
+            makeBranches();
             return true;
         }
         else
@@ -423,24 +428,4 @@ public class WorldFeatureTreeFancy extends WorldFeature
             return false;
         }
     }
-
-    static final byte dimensionLookup[] = {
-        2, 0, 0, 1, 2, 1
-    };
-    Random treeRand;
-    World worldObj;
-    int basePos[] = { 0, 0, 0 };
-    int height;
-    int trunkHeight;
-    double trunkHeightScale;
-    double field_875_h;
-    double field_874_i;
-    double field_873_j;
-    double field_872_k;
-    int trunkThickness;
-    int trunkHeightVariance;
-    int leavesHeight;
-    int branchPoints[][];
-    int heightMod;
-
 }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
new file mode 100644
index 000000000..9aef45d9b
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
@@ -0,0 +1,81 @@
+package net.minecraft.core.world.generate.feature.tree.spooner;
+
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.WorldFeature;
+
+import java.util.List;
+import java.util.Random;
+
+public abstract class WorldFeatureSpoonerTree
+    extends WorldFeature {
+    protected static int distToMat(double[] coord, double[] vec, List<Integer> matidxlist, World world, boolean invert, double limit) {
+        /* travel from cord along vec and return how far it was to a point of matidx
+         *
+         * the distance is returned in number of iterations. If the edge of the map
+         * is reached, then return the number of iterations as well.
+         * if invert == true, search for anything other than those in matidxlist
+         */
+        double[] curCoord = new double[] { coord[0] + 0.5, coord[1] + 0.5, coord[2] + 0.5 };
+        int iterations = 0;
+        while (true) {
+            int x = (int) Math.floor(curCoord[0]);
+            int y = (int) Math.floor(curCoord[1]);
+            int z = (int) Math.floor(curCoord[2]);
+            int blockId = world.getBlockId(x, y, z);
+            if (matidxlist.contains(blockId) && !invert) {
+                break;
+            } else if (!matidxlist.contains(blockId) && invert) {
+                break;
+            } else {
+                for (int i = 0; i < 3; i++) {
+                    curCoord[i] += vec[i];
+                }
+                iterations++;
+            }
+            if (limit != 0.0 && iterations > limit) {
+                break;
+            }
+        }
+        return iterations;
+    }
+
+    protected static boolean assignValue(int x, int y, int z, int id, int meta, World world) {
+        /* assign a block to the world */
+        return world.setBlockAndMetadata(x, y, z, id, meta);
+    }
+
+    protected final int[] pos;
+    protected final int height;
+    protected final int trunkId;
+    protected final int trunkData;
+    protected final int leavesId;
+    protected final int leavesData;
+
+    protected Random random = null;
+
+    public WorldFeatureSpoonerTree(int x, int y, int z, int height, int trunkId, int trunkData, int leavesId, int leavesData) {
+        this.pos = new int[] { x, y, z };
+        this.height = height;
+        this.trunkId = trunkId;
+        this.trunkData = trunkData;
+        this.leavesId = leavesId;
+        this.leavesData = leavesData;
+    }
+
+    protected void prepare(World world) { }
+
+    protected void makeTrunk(World world) { }
+
+    protected void makeFoliage(World world) { }
+
+    @Override
+    public boolean generate(World world, Random random, int x, int y, int z) {
+        this.random = random;
+
+        prepare(world);
+        makeFoliage(world);
+        makeTrunk(world);
+
+        return false;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeBamboo.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeBamboo.java
new file mode 100644
index 000000000..143a4c596
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeBamboo.java
@@ -0,0 +1,28 @@
+package net.minecraft.core.world.generate.feature.tree.spooner;
+
+import net.minecraft.core.world.World;
+
+public class WorldFeatureSpoonerTreeBamboo
+    extends WorldFeatureSpoonerTreeStick {
+    public WorldFeatureSpoonerTreeBamboo(int x, int y, int z, int height, int trunkId, int trunkData, int leavesId, int leavesData) {
+        super(x, y, z, height, trunkId, trunkData, leavesId, leavesData);
+    }
+
+    @Override
+    /* Set up the foliage for a bamboo tree.
+     * Make foliage sparse and adjacent to the trunk.
+     */
+    protected void makeFoliage(World world) {
+        int start = this.pos[1];
+        int end = this.pos[1] + this.height + 1;
+        for (int y = start; y < end; y++) {
+            for (int i = 0; i < 2; i++) {
+                int xoff = random.nextInt(2) * 2 - 1;
+                int zoff = random.nextInt(2) * 2 - 1;
+                int x = this.pos[0] + xoff;
+                int z = this.pos[2] + zoff;
+                assignValue(x, y, z, this.leavesId, this.leavesData, world);
+            }
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeCone.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeCone.java
new file mode 100644
index 000000000..1aaa6de03
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeCone.java
@@ -0,0 +1,35 @@
+package net.minecraft.core.world.generate.feature.tree.spooner;
+
+import net.minecraft.core.world.World;
+
+public class WorldFeatureSpoonerTreeCone
+    extends WorldFeatureSpoonerTreeProcedural {
+    public WorldFeatureSpoonerTreeCone(int x, int y, int z, int height, int trunkId, int trunkData, int leavesId, int leavesData) {
+        super(x, y, z, height, trunkId, trunkData, leavesId, leavesData);
+    }
+
+    @Override
+    protected void prepare(World world) {
+        super.prepare(world);
+        this.branchSlope = 0.15;
+        this.foliageShape = new double[] { 3, 2.6, 2, 1 };
+        this.trunkRadius = this.trunkRadius * 0.618;
+        this.trunkHeight = this.height;
+    }
+
+    @Override
+    protected Double shapeFunc(int y) {
+        Double twigs = super.shapeFunc(y);
+        if (twigs != null) {
+            return twigs;
+        }
+        if (y < this.height * (0.25 + 0.05 * Math.sqrt(random.nextDouble()))) {
+            return null;
+        }
+        double radius = (this.height - y) * 0.382;
+        if (radius < 0) {
+            radius = 0;
+        }
+        return radius;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeMangrove.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeMangrove.java
new file mode 100644
index 000000000..493792162
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeMangrove.java
@@ -0,0 +1,27 @@
+package net.minecraft.core.world.generate.feature.tree.spooner;
+
+import net.minecraft.core.world.World;
+
+public class WorldFeatureSpoonerTreeMangrove
+    extends WorldFeatureSpoonerTreeRound {
+    public WorldFeatureSpoonerTreeMangrove(int x, int y, int z, int height, int trunkId, int trunkData, int leavesId, int leavesData) {
+        super(x, y, z, height, trunkId, trunkData, leavesId, leavesData);
+    }
+
+    @Override
+    protected void prepare(World world) {
+        super.prepare(world);
+        this.branchSlope = 1.0;
+        this.trunkRadius = this.trunkRadius * 0.618;
+    }
+
+    @Override
+    protected Double shapeFunc(int y) {
+        Double val = super.shapeFunc(y);
+        if (val == null) {
+            return val;
+        }
+        val = val * 1.618;
+        return val;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeNormal.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeNormal.java
new file mode 100644
index 000000000..958bc8c93
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeNormal.java
@@ -0,0 +1,44 @@
+package net.minecraft.core.world.generate.feature.tree.spooner;
+
+import net.minecraft.core.world.World;
+
+public class WorldFeatureSpoonerTreeNormal
+    extends WorldFeatureSpoonerTreeStick {
+
+    public WorldFeatureSpoonerTreeNormal(int x, int y, int z, int height, int trunkId, int trunkData, int leavesId, int leavesData) {
+        super(x, y, z, height, trunkId, trunkData, leavesId, leavesData);
+    }
+
+    @Override
+    /* Set up the foliage for a 'normal' tree.
+     *
+     * This tree will be a single bulb of foliage above a single width trunk.
+     * This shape is very similar to the default Minecraft tree.
+     */
+    protected void makeFoliage(World world) {
+        int topY = this.pos[1] + this.height - 1;
+        int start = topY - 2;
+        int end = topY + 2;
+        for (int y = start; y < end; y++) {
+            int rad;
+            if (y > start + 1) {
+                rad = 1;
+            } else {
+                rad = 2;
+            }
+
+            for (int xoff = -rad; xoff < rad + 1; xoff++) {
+                for (int zoff = -rad; zoff < rad + 1; zoff++) {
+                    if (random.nextDouble() > 0.618 && Math.abs(xoff) == Math.abs(zoff) && Math.abs(xoff) == rad) {
+                        continue;
+                    }
+
+                    int x = this.pos[0] + xoff;
+                    int z = this.pos[2] + zoff;
+
+                    assignValue(x, y, z, this.leavesId, this.leavesData, world);
+                }
+            }
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreePalm.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreePalm.java
new file mode 100644
index 000000000..5c7525d17
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreePalm.java
@@ -0,0 +1,24 @@
+package net.minecraft.core.world.generate.feature.tree.spooner;
+
+import net.minecraft.core.world.World;
+
+public class WorldFeatureSpoonerTreePalm
+    extends WorldFeatureSpoonerTree {
+
+    public WorldFeatureSpoonerTreePalm(int x, int y, int z, int height, int trunkId, int trunkData, int leavesId, int leavesData) {
+        super(x, y, z, height, trunkId, trunkData, leavesId, leavesData);
+    }
+
+    @Override
+    protected void makeFoliage(World world) {
+        int y = this.pos[1] + this.height;
+        for (int xoff = -2; xoff < 3; xoff++) {
+            for (int zoff = -2; zoff < 3; zoff++) {
+                int x = this.pos[0] + xoff;
+                int z = this.pos[2] + zoff;
+
+                assignValue(x, y, z, this.leavesId, this.leavesData, world);
+            }
+        }
+    }
+}
